
DualFace::usage = "DualFace[faces, vertex], where faces are the faces of a 
polyhedron (lists of indices of vertices) and vertex is one of the 
polyhedron's vertices, gives the face corresponding to vertex in the dual 
polyhedron."

Dual::usage = "Dual[{vertices, faces}], where the argument represents a 
polyhedron in that vertices is a list of ntuples and faces is a list of 
indices to the vertices, gives another such list representing the dual of the 
polyhedron."

DualFace[faces_, vertex_] := 
	Flatten[
		Position[faces, #]& /@ SortFaces[faces, vertex]
	]

Dual @ {faces_, vertices_} := 
	{
		DualFace[faces, #]& /@ Range[Length @ vertices],
		Centroid @ vertices[[#]]& /@ faces
	}

