
FaceVertexPairsAux @ face_ := {face, #}& /@ face

FaceVertexPairs @ faces_ := Flatten[FaceVertexPairsAux /@ faces, 1]

FaceAtVertexForVerticesOnFaces[faces_, vertex_] := Flatten @ 
	Map[
		Position[FaceVertexPairs @ faces, #] &,
		{#, vertex} & /@ SortFaces[faces, vertex]
	]

FacesAtVerticesForVerticesOnFaces @ {faces_, vertices_} := 
	FaceAtVertexForVerticesOnFaces[faces, #]& /@ Range[Length @ vertices]

FaceAtFaceForVerticesOnFaces[faces_, face_] :=
	Flatten[
		Map[
			Position[FaceVertexPairs @ faces, #]&,
			{face, #} & /@ face
		]
	]

FacesAtFacesForVerticesOnFaces @ faces_ := 
	FaceAtFaceForVerticesOnFaces[faces, #]& /@ faces

FaceAtEdgeForVerticesOnFaces[faces_, edge_] := Module[
	{f, g, a, b},
	{f, g} = Select[faces, SubsetQ[#, edge]&];
	{a, b} = edge;
	Flatten[
		Position[FaceVertexPairs @ faces, #]& /@ 
			{{f, a}, {f, b}, {g, b}, {g, a}}
	]
]

FacesAtEdgesForVerticesOnFaces @ faces_ := 
	FaceAtEdgeForVerticesOnFaces[faces, #]& /@ 
		RemoveDuplicateEdges[EdgesAroundFaces @ faces]

FacesForVerticesOnFaces @ {faces_, vertices_} := Join[
	FacesAtVerticesForVerticesOnFaces @ {faces, vertices},
	FacesAtFacesForVerticesOnFaces @ faces,
	FacesAtEdgesForVerticesOnFaces @ faces
]

