
NetLines::usage = 
"NetLines[{x0, x1, dx}, {y0, y1, dy}] gives a list of lines, one for each x in 
the range from x0 to x1 in steps of dx and one for each y in the range from y0 
to y1 in steps of dy. A line of one type contains the points where it 
intersects the lines of the other type.
Each of NetLines[x, {y0, y1, dy}] and NetLines[{x0, x1, dx}, y] give a single 
line."

NetLines[{x0_, x1_, dx_}, {y0_, y1_, dy_}] := 
	Map[Line, Join[#, Thread @ #]] & @ 
		NetTriples[{x0, x1, dx}, {y0, y1, dy}] 

NetLines[x_, {y0_, y1_, dy_}] := Line @ NetTriples[x, {y0, y1, dy}] 

NetLines[{x0_, x1_, dx_}, y_] := Line @ NetTriples[{x0, x1, dx}, y] 

