
SphereLines::usage = 
"SphereLines[{u0, u1, du}, {v0, v1, dv}] gives a list of lines which are parts 
of the latitudes and longitudes on the sphere. The latitudes are between the 
angles v0 and v1 with a spacing of dv. The longitudes are between great the 
circles with angles u0 and u1 with a spacing of du. 
Each of SphereLines[r, {t0, t1, dt}] and SphereLines[{r0, r1, dr}, t] give a 
single line."

( SphereLines[{u0_, u1_, du_}, {v0_, v1_, dv_}] := Module[
	{t = SphereTriples[{u0, u1, du}, {v0, v1, dv}]},
	{Line /@ t, Line /@ Thread[t]}
	]
)

SphereLines[u_, {v0_, v1_, dv_}] := Line @ SphereTriples[u, {v0, v1, dv}] 

SphereLines[{u0_, u1_, du_}, v_] := Line @ SphereTriples[{u0, u1, du}, v] 

