
SpherePoints::usage = 
"SpherePoints[{u0, u1, du}, {v0, v1, dv}] gives a list of points where parts 
of the latitudes and longitudes on the sphere cross. The latitudes are between 
angles v0 and v1 with a spacing of dv. The longitudes are between great 
circles at the angles u0 and u1 with a spacing of du.
Each of SpherePoints[u, {v0, v1, dv}] and SpherePoints[{u0, u1, du}, v] gives 
a list of points, also."

( SpherePoints[{u0_, u1_, du_}, {v0_, v1_, dv_}] := 
	Point /@ Flatten[SphereTriples[{u0, u1, du}, {v0, v1, dv}], 1] )

SpherePoints[u_, {v0_, v1_, dv_}] := Point /@ SphereTriples[u, {v0, v1, dv}]

SpherePoints[{u0_, u1_, du_}, v_] := Point /@ SphereTriples[{u0, u1, du}, v]

