
Binormal::usage = "Binormal[f, u, x, du] gives the ray of length x from f[u] 
perpendicular to the osculating plane of f: R -> R ^ 3."

Binormal[f_, u_?NumberQ, x_?NumberQ, du_:.01] := Module[
	{v}, 
	v = Cross[
		Vector[Tangent[f, u - du, x, du]], 
		Vector[Tangent[f, u + du, x, du]]];
	Ray[Line[{f[u], f[u] + v}], x] 
] 

Binormal[f_, l_List, x_?NumberQ, du_:.01] := Binormal[f, #, x, du] & /@ l 

