
NormalPlane::usage = "NormalPlane[f, u, x, du] gives the plane through the 
principal normal and binormal to the function f: R -> R ^ 3 at f[u]."

NormalPlane[f_, u_?NumberQ, x_?NumberQ, du_:.01] := Plane @ 
	{
		f[u], 
		PrincipalNormal[f, u, x, du][[1, 2]], 
		Binormal[f, u, x, du][[1, 2]]
	}

NormalPlane[f_, l_List, x_?NumberQ, du_:.01] := 
	NormalPlane[f, #, x, du] & /@ l 

