
RectifyingPlane::usage = "RectifyingPlane[f, u, x, du] gives the plane through 
the tangent and binormal to the function f: R -> R ^ 3 at f[u]."

RectifyingPlane[f_, u_?NumberQ, x_?NumberQ, du_:.01] := Plane @ 
	{
		f[u], 
		Binormal[f, u, x, du][[1, 2]], 
		Tangent[f, u, x, du][[1, 2]]
	}

RectifyingPlane[f_, l_List, x_?NumberQ, du_:.01] := 
	RectifyingPlane[f, #, x, du] & /@ l 

