
FaceAtVertexForVerticesOnEdges[faces_, vertex_] := 
	Flatten[
		Position[EdgesAroundFaces @ faces, #]& /@ 
			SortEdges[faces, vertex]
	]

FaceAtFaceForVerticesOnEdges[faces_, face_] := 
	Flatten[
		Position[EdgesAroundFaces @ faces, #]& /@ 
			Flatten[Thread @ {#, Reverse /@ #} & @ 
				EdgesAroundFace @ face, 1]
	]

FacesForVerticesOnEdges @ {faces_, vertices_} := Join[
	FaceAtVertexForVerticesOnEdges[faces, #]& /@ 
		Range[Length @ vertices],
	FaceAtFaceForVerticesOnEdges[faces, #]& /@ faces
]

FaceAtVertexForVerticesAtMidpoints[faces_, vertex_] := 
	Flatten[
		Position[
			RemoveDuplicateEdges @ EdgesAroundFaces @ faces, 
			#
		]& /@ Flatten[
				Thread @ {#, Reverse @ #} & /@ 
					SortEdges[faces, vertex],
				1
			]
	]

FaceAtFaceForVerticesAtMidpoints[faces_, face_] := 
	Flatten[
		Position[
			RemoveDuplicateEdges @ EdgesAroundFaces @ faces, 
			#]& /@ Flatten[
					Thread @ {#, Reverse @ #} & /@ 
						EdgesAroundFace @ face, 
					1
				]
	]

FacesForVerticesAtMidpoints @ {faces_, vertices_} := Join[
	FaceAtVertexForVerticesAtMidpoints[faces, #]& /@ 
		Range[Length @ vertices],
	FaceAtFaceForVerticesAtMidpoints[faces, #]& /@ faces
]

