
NetTriples::usage = 
"NetTriples[{x0, x1, dx}, {y0, y1, dy}] gives a nested list of triples with x 
coordinates running from x0 to x1 in steps of dx and y coordinates running 
from y0 to y1 in steps of dy.
Each of NetTriples[x, {y0, y1, dy}] and NetTriples[{x0, x1, dx}, y] gives 
a list of triples."

( NetTriples[{x0_, x1_, dx_}, {y0_, y1_, dy_}] := Module[
	{x, y}, 
	Table[
		ToTriple[x + I y], 
		{x, x0, x1, dx}, {y, y0, y1, dy}
	]
] )

( NetTriples[x_, {y0_, y1_, dy_}] := Module[
	{y}, 
	Table[
		ToTriple[x + I y], 
		{x, x0, x1, dx}
	]
] )

( NetTriples[{x0_, x1_, dx_}, y_] := Module[
	{x}, 
	Table[
		ToTriple[x + I y], 
		{x, x0, x1, dx}
	]
] )


