
PreDraw3D::usage = "PreDraw3D[f] prepares the figure f for drawing in three 
dimensions."

( PreDraw3D[m_] := m 
	/; MemberQ[{Point, Polygon, GrayLevel, RGBColor, PointSize, 
	AbsolutePointSize, Thickness, AbsoluteThickness, FaceForm, EdgeForm}, 
	Head @ m] )

PreDraw3D @ Text[___] := {}

PreDraw3D @ Point @ x_ := Point @ ToTriple @ x 

PreDraw3D @ Line @ l_ := Line[ToTriple /@ l]

PreDraw3D @ Circle[c:{_, _, _}, r_] := 
	PreDraw3D @ Circle3D[c, c + r $i, c + r $j] 

PreDraw3D @ Circle[c:{_, _, _}, r_, n_] := 
	PreDraw3D @ Circle3D[c, c + r $i, c + r $j, n] 

PreDraw3D @ Circle3D[c_, d_, e_] := 
	Line @ Map[c + Cos[#] (d - c) + Sin[#] (e - c) &, 
	2 N[Pi] Range[0, 1, 1 / $PointsOnCircle]] 

PreDraw3D @ Circle3D[c_, d_, e_, n_] := 
	Line @ Map[c + Cos[#] (d - c) + Sin[#] (e - c) &, 
	2 N[Pi] Range[0, 1, 1 / n]] 

PreDraw3D @ Plane @ {p_, q_, r_} := PreDraw3D @ 
	OutlinePolygon[Polygon @ { q, r, 2 p - q, 2 p - r}, $PlaneOpening]

PreDraw3D @ Sphere[c_?PointQ, r_] := {EdgeForm[], Polygon /@ Flatten[
	Translate[c] 
		[r Map[
			Unit, 
			TriangulateTwice @ Vertices[Icosahedron] [[#]]& /@
				Faces[Icosahedron],
			{3}
		]], 
	1
]}

PreDraw3D @ OpenSphere[c_?PointQ, r_, s_] := 
{
	OutlinePolygon[Polygon @ #, s]& /@ Flatten[
			Translate[c] [r Map[
				Unit, 
				TriangulateTwice @ 
					Vertices[Icosahedron] [[#]]& /@
						Faces[Icosahedron],
				{3}
			]], 
			1
		]
}

PreDraw3D @ h_List := PreDraw3D /@ h

