
Project::usage = "Project[x][g] is the orthogonal projection of the figure g onto the line, plane, or hyperplane x."

Project[x_] @ p_?PointQ := (p + Reflect[x] @ p) / 2 

Project[x_] @ g_ := MapAt[Project[x] @ # &, g, Position[g, _?PointQ]] 

Projectxy::usage = "Projectxy[g] gives the projection of the graphics g onto 
the xy plane."

Projectxy[g_] := Transformation[{#[[1]], #[[2]], 0} &][g]

Projectyz::usage = "Projectyz[g] gives the projection of the graphics g onto 
the yz plane."

Projectyz[g_] := Transformation[{0, #[[2]], #[[3]]} &][g]

Projectzx::usage = "Projectzx[g] gives the projection of the graphics g onto 
the zx plane."

Projectzx[g_] := Transformation[{#[[1]], 0, #[[3]]} &][g]

