
Reflect::usage = "
Reflect[p][g] is the reflection of the figure g in the line p. 
Reflect[l][g] is the reflection of the figure g in the line l. 
Reflect[w][g] is the reflection of the figure g in the plane w
Reflect[h][g] is the reflection of the figure g in the hyperplane h."

Reflect[p_?PointQ] @ g_ := Rotate[N@Pi, p] @ g

Reflect[Line @ l_] @ g_ := Rotate[N@Pi, l] @ g

Reflect[w_Plane] @ p:_?PointQ := Module[ 
	{n, q, r},
	n =  ToQuaternion @ Unit @ PlaneNormal @ w;
	q = First @ First @ w;
	r = ToQuaternion[p - q];
	Chop[q + Rest @ QTimes[QTimes[n, r], n]] ] 

Reflect[w_Plane] @ g_ := MapAt[Reflect[w] @ # &, g, Position[g, _?PointQ]] 

(*
Reflect[h_Hyperplane] @ p_?PointQ := Module[
 {}, 
 n = HyperplaneNormal[h]; 
 
]
*)

Reflect[l_List] @ g_ := Reflect[#] @ g & /@ l

