
Ridge[{u_, v_, ___}] := 
	u $i + (1 - v) $j + .25 (1 - v)^2 Sin[(8 u -.5) Pi] $k

Saddle[{u_, v_, ___}] := Module[
{x = 2 u - 1, y = 2 v - 1},
x $i + y $j + x y (y^2 - x^2) / (x^2 + y^2) $k
]


Octagon[m_, n_, x_] := Polygon[.5 {
	  $i / m - x $j / n,
	  $i / m + x $j / n,	 
	  $j / n + x $i / m,
	  $j / n - x $i / m,
	 -$i / m + x $j / n,
	 -$i / m - x $j / n,	 
	 -$j / n - x $i / m,
	 -$j / n + x $i / m
}]

StJohnCross[m_, n_, x_] := Module[
	{a,b,c,d,e,f,g,h,i,j}, 
	a = Translate[- .1 5 $j/n] [.1 {-3 $i, -1 $i, $o, $i, 3 $i} / m];  
	b = Translate[- .1 4 $j/n] [.1 {-4 $i, -3 $i, -2 $i, $o, 4 $i} / m];
	c = Translate[- .1 3 $j/n] [.1 {-5 $i, -3 $i, 1 $i, 3 $i, 4 $i} / m];
	d = Translate[- .1 2 $j/n] [.1 {-2 $i, 0 $i, 1 $i, 2 $i, 4 $i} / m]; 
	e = Translate[- .1 1 $j/n] [.1 {-5 $i, -3 $i, -2 $i, -1 $i, 1 $i} / m];				
	f = Translate[- .1 0 $j/n] [.1 {-5 $i, -4 $i, -2 $i, 2 $i, 4 $i} / m];
	g = Translate[  .1 1 $j/n] [.1 {-5 $i, -1 $i, 1 $i, 2 $i, 3 $i} / m]; 
	h = Translate[  .1 2 $j/n] [.1 {-4 $i, -2 $i, -1 $i, 0 $i, 2 $i} / m];
	i = Translate[  .1 3 $j/n] [.1 {-5 $i, -4 $i, -3 $i, -1 $i, 3 $i} / m];
	j = Translate[  .1 4 $j/n] [.1 {-4 $i, 0 $i, 2 $i, 3 $i, 4 $i} / m];
	{EdgeForm[], Translate[{a,b,c,d,e,f,g,h,i,j}] @ Polygon [ 
		.1 .5 {$i/m + $j/n, -$i/m + $j/n, -$i/m - $j/n, $i/m - $j/n}], 
	Translate[ {a[[1]],b[[5]],c[[3]],d[[1]],e[[1]],f[[4]],g[[2]],h[[1]],i[[5]],j[[2]]} 
		] @ Line[.1 .5 
		{-$i/m + $j/n, -$i/m - $j/n, $i/m - $j/n, $i/m + $j/n}],
 	Translate[ {a[[2]],b[[1]],c[[4]],d[[2]],e[[2]],f[[5]],g[[3]],h[[2]],i[[1]],j[[3]]} 
		] @ Line[.1 .5 
		{$i/m + $j/n, -$i/m + $j/n, -$i/m - $j/n, $i/m - $j/n}],
	Translate[ {a[[4]],b[[3]],c[[1]],d[[4]],e[[4]],f[[2]],g[[5]],h[[4]],i[[3]],j[[5]]} 
		] @ Line[.1 .5 
		{-$i/m - $j/n, $i/m - $j/n, $i/m + $j/n, -$i/m + $j/n}],
	Translate[ {a[[5]],b[[4]],c[[2]],d[[5]],e[[5]],f[[3]],g[[1]],h[[5]],i[[4]],j[[1]]} 
		] @ Line[.1 .5 
		{$i/m - $j/n, $i/m + $j/n, -$i/m + $j/n, -$i/m - $j/n}]
}
]

Skin[m_, n_, x_, motif_, surface_] := 
  Module[{lattice}, lattice = 
     Translate[(0.5*$i)/m + (0.5*$j)/n][Lattice[m, $i/m, n, $j/n]]; 
    Transformation[surface][Translate[lattice][motif[m, n, 
         x]]]
]
