
TruncateVertices[{faces_, vertices_}, t_] := 
	{
		FacesForVerticesOnEdges @ {faces, vertices}, 
		VerticesOnEdges[{faces, vertices}, t]
	} /; t < .5

TruncateVertices[{faces_, vertices_}, t_] := 
	{
		FacesForVerticesAtMidpoints @ {faces, vertices}, 
		VerticesAtMidpoints @ {faces, vertices}
	} /; t == .5

TruncateVertices[{faces_, vertices_}, t_] := 
	{
		FacesForMidpointsOnFaces @ {faces, vertices}, 
		MidpointsOnFaces[{faces, vertices}, 2 t - 1]
	} /; .5 < t 

TruncateEdges[{faces_, vertices_}, t_] := 
	{
		FacesForVerticesOnFaces @ {faces, vertices},
		VerticesOnFaces[{faces, vertices}, t]
	} /; t < 1

TruncateEdges[{faces_, vertices_}, t_] := Dual @ {faces, vertices} /; t == 1

TruncateVerticesAnimation[g_, t_] := 
	Draw3D[Realize @ TruncateVertices[g, t], Lighting -> True]

TruncateEdgesAnimation[g_, t_] := 
	Draw3D[Realize @ TruncateEdges[g, t], Lighting -> True]

