
GridBackdrop::usage = "GridBackdrop[f, m, n, c, x] is the image of m n 
polygons with colour c under the mapp[Bing f: R ^ 2 -> R ^ 3, displaced along 
the line of sight by x (default -.01)."

OctagonBackdrop::usage = "OctagonBackdrop[f, m, n, x] is the image of m n 
regular octagons under the mapping f: R ^ 2 -> R ^ 3, displaced along the line 
of sight by x (default -.01)."

GridBackdrop[f_, m_?NumberQ, n_?NumberQ, c_, x_:-.01] := 
	Translate[x (ViewPoint /. Options[Graphics3D])] @ 
	Transformation[f] @ 
	Translate[Lattice[m, $i / m, n, $j / n]] @ 
	{EdgeForm[], c, Polygon @ {$o, $i / m, $i / m + $j / n, $j / n}}

OctagonBackdrop[f_, m_?NumberQ, n_?NumberQ, c1_, c2_, x_:-.01] := 
	Translate[x (ViewPoint /. Options[Graphics3D])] @ 
	Transformation[f] @ 
	Translate[Lattice[m, $i / m, n, $j / n]] @ 
	Dilate[$o, .4 / Max[m, n]] @ 
	{FaceForm[c1, c2], EdgeForm[], Polygon @ RegularPolygon[8]}

