
LowDiagonalsBackdrop::usage = "LowDiagonalsBackdrop[f, m, n, c, x] is the 
image of 2 m n polygons (m n rectangles split by diagonals of slope 1 / m) 
with colour c under the mapping f: R ^ 2 -> R ^ 3, displaced along the line of 
sight by x (default -.01)."

LowDiagonals::usage = "LowDiagonals[f, m, n, c] is the image of the lines of 
colour c through the corners of m n small rectangles in the unit square with 
slope 1 / m under the mapping f: R ^ 2 -> R ^ 3."

HighDiagonalsBackdrop::usage = "HighDiagonalsBackdrop[f, m, n, c, x] is the 
image of 2 m n polygons (m n rectangles split by diagonals of slope n) 
with colour c under the mapping f: R ^ 2 -> R ^ 3, displaced along the line of 
sight by x (default -.01)."

HighDiagonals::usage = "HighDiagonals[f, m, n, c] is the image of lines of 
colour c through the corners of m n small rectangles in the unit square with 
slope n under the mapping f: R ^ 2 -> R ^ 3."

LowDiagonalsBackdrop[f_, m_?NumberQ, n_?NumberQ, c_, x_:-.01] := 
	Translate[x (ViewPoint /. Options[Graphics3D])] @ Transformation[f] @ 
		Translate[Lattice[n, $j / n]] @
			{
				EdgeForm[], c, 
				Polygon[
					{
						(# - 1) / m ($i + $j / n),
						# / m ($i + $j / n), 
						# $i / m, 
						(# - 1) $i / m
					}
				] & /@ Range[m], 
				Polygon[
					{
						(# - 1) / m ($i + $j / n), 
						# / m ($i + $j / n), 
						# / m $i + $j / n, 
						(# - 1) / m $i + $j /n
					}
				] & /@ Range[m]
			}

LowDiagonals[f_, m_?NumberQ, n_?NumberQ, c_] := Transformation[f] @ 
	Translate[Lattice[n, $j / n]] [
			{Thickness[.0035], c, Line[{(# - 1) / m ($i + $j /n), 
				# / m ($i + $j / n)}]} & /@ Range[m]
		] 

HighDiagonalsBackdrop[f_, m_?NumberQ, n_?NumberQ, c_, x_:-.01] := 
	LowDiagonalsBackdrop[f[{$j, $i, $k} . #] &, m, n, c, x] 

HighDiagonals[f_, m_?NumberQ, n_?NumberQ, c_] := 
	LowDiagonals[f[{$j, $i, $k} . #] &, n, m, c] 

